#include <stdbool.h>
#include <stdint.h>
#include <stddef.h>

#define COMMAND_GET_ID                 0x1101
#define COMMAND_SET_INFO               0x1102
#define COMMAND_SET_COMPLETE           0x1103
#define COMMAND_DELETE_INFO            0x1104
#define COMMAND_TIRE_NEWSTOCKE         0x1201
#define COMMAND_TIRE_RESTOCKE          0x1202
#define COMMAND_TIRE_DISPOSE           0x1203


typedef struct _TCmdTbl
{
   uint8_t       idx;
   char*         cmd;
   uint8_t       len;
   uint8_t       mask;  // Feature masking without args
   uint8_t       amask; // Feature masking with args
   uint8_t       (*hdl)(char*, struct _TCmdTbl* tbl, char*); // Handler
} TCmdTbl;


#define M_UNABLE 0x00

#define IS_SMALL_LETTER(a)  (((a) >= 'a') && ((a) <= 'z'))
#define ARR_SIZE( a ) ( sizeof( (a) ) / sizeof( (a[0]) ) )


static uint8_t ResponseCommandHandler(char* out, TCmdTbl* tbl, char* args);
static uint8_t TxModeSwitchHandler(char* out, TCmdTbl* tbl, char* args);
static uint8_t RxModeSwitchHandler(char* out, TCmdTbl* tbl, char* args);
static uint8_t DeleteInfoResponseCommandHandler(char* out, TCmdTbl* tbl, char* args);
static uint8_t NewStockeResponseCommandHandler(char* out, TCmdTbl* tbl, char* args);
static uint8_t RestockeResponseCommandHandler(char* out, TCmdTbl* tbl, char* args);

static void    uartTaskFunction(UArg arg0, UArg arg1);
void           ParserReceiverMgr(uint8_t *mMsg, int len);
static uint8_t TxCommandHandler(uint8_t* data, uint8_t len);

void           rfEasyLink_Uart_init(void);


